window.debug = %s;
/*links*/
window.dp_prev_url = '%s';
window.dp_menu_url = '%s';
window.dp_next_url = '%s';
/* page number */
window.dp_page_num = %d;
/*background loading result*/
window.dp_ok = %s;

var debugReader = false;
var debugPrevLoader = false;
var debugNextLoader = false;
var debug_iframe = false;

/*创建调试信息容器*/
function CreateDebugDiv(name, left) {
    if (debug && window.top == window) {
        var div = document.createElement("div");
        div.innerHTML = name;
        if (left > 0) {
            if (left == 1){
                div.className = 'debugLeft';
            } else {
                div.className = 'debugRight';
            }
        } else {
            div.className = 'debugALL';
        }
        document.body.appendChild(div);
        return div;
    }
    return null;
}

function LogDebugMsg(div, msg) {
    if (div) {
        var a = document.createElement("div");
        a.innerHTML = msg;
        while (div.childNodes.length > 5) {
            div.removeChild(div.firstChild);
        }
        div.appendChild(a);
    }
}

/*常用函数集成，以便修改兼容*/
var baina = {
    $: function (id) {
        return document.getElementById(id);
    },
    hasClass: function (dom, className) {
        return dom.className.match(new RegExp("(\\s|^)" + className + "(\\s|baina.$)"));
    },
    addClass: function (dom, className) {
        if (!this.hasClass(dom, className)) {
            dom.className += " " + className;
        }
    },
    removeClass: function (dom, className) {
        dom.className = dom.className.replace(new RegExp("(\\s|^)" + className + "(\\s|baina.$)"), "");
    },
    addEvent: function (dom, type, fn) {
        return dom.addEventListener(type, fn, false);
    },
    stopEvent: function (event) {
        event.preventDefault();
        event.stopPropagation();
    },
    addChildEnd: function (parent, child, pos) {
        if(pos != false){
            parent.appendChild(child);
        } else {
            parent.insertBefore(child, parent.childNodes[0]);
        }
    },
    prevSibling: function(dom) {
        if(dom.previousSibling.nodeType === 1){
            return dom.previousSibling;
        } else {
            return this.prevSibling(dom.previousSibling);
        }
    },
    firstElemChild: function(dom) {
        if(dom.nodeType === 1){
            return dom;
        } else {
            return this.firstElemChild(dom.nextSibling);
        }
    },
    getNetInfo: function(){
        return window.navigator.onLine;
    }
};

/*显示、隐藏切换控件*/
function Widget(id) {
    this.dom = baina.$(id);
}

Widget.prototype.IsShow = function() {
    return this.dom.style['display'] != 'none';
};

Widget.prototype.Show = function(fShow) {
    this.dom.style['display'] = (fShow != false ? 'block' : 'none');
};

/*用于显示页面信息的 Bar，将显示和隐藏封装*/
function Bar(barId) {
    barId = barId.slice(0, -4);

    var loadingTipId = barId + 'loading_tip';
    var errorTipId = barId + 'loading_error_tip';
    var boundaryTip = barId + 'boundary_tip';
    var fnErrorTip = barId + 'fn_error_tip';

    this.loadingTip = new Widget(loadingTipId);
    this.errorTip = new Widget(errorTipId);
    this.boundaryTip = new Widget(boundaryTip);
    this.fnErrorTip = new Widget(fnErrorTip);
}

Bar.prototype.Init = function() {
    this.ShowLoaddingTip(false);
    this.ShowErrorTip(false);
    this.ShowBoundaryTip(false);
    this.ShowFnErrorTip(false);
};

Bar.prototype.IsLoadingTipShow = function() {
    return this.loadingTip.IsShow();
};

Bar.prototype.IsErrorTipShow = function() {
    return this.errorTip.IsShow();
};

Bar.prototype.IsBoundaryTipShow = function() {
    return this.boundaryTip.IsShow();
};

Bar.prototype.IsFnErrorTipShow = function() {
    return this.fnErrorTip.IsShow();
};
/*显示前先进行判断，显得有点多余，但是很安全*/
Bar.prototype.ShowLoaddingTip = function(fShow) {
    if (fShow != false) {
        this.loadingTip.dom.className = 'recover_loading';/*loading的状态分为，加载中or停止加载*/
        this.errorTip.IsShow() && this.errorTip.Show(false);
        this.boundaryTip.IsShow() && this.boundaryTip.Show(false);
        this.loadingTip.Show();
    } else {
        this.loadingTip.Show(false);
    }
};

Bar.prototype.ShowErrorTip = function(fShow) {
    if (fShow != false) {
        this.loadingTip.IsShow() && this.loadingTip.Show(false);
        this.boundaryTip.IsShow() && this.boundaryTip.Show(false);
        this.errorTip.Show();
    } else {
        this.errorTip.Show(false);
    }
};

Bar.prototype.ShowBoundaryTip = function(fShow) {
    if (fShow != false) {
        this.loadingTip.IsShow() && this.loadingTip.Show(false);
        this.errorTip.IsShow() && this.errorTip.Show(false);
        this.boundaryTip.Show();
    } else {
        this.boundaryTip.Show(false);
    }
};

Bar.prototype.ShowFnErrorTip = function(fShow) {
    if (fShow != false) {
        this.loadingTip.IsShow() && this.loadingTip.Show(false);
        this.boundaryTip.IsShow() && this.boundaryTip.Show(false);
        this.fnErrorTip.Show();
    } else {
        this.fnErrorTip.Show(false);
    }
};

/*页面加载处理部分，通过设置状态变量来区分加载、回调*/
function Loader(loadFrameId, callbackObj, callbackFn, div) {
    this.loadDom = baina.$(loadFrameId);
    this.callbackFn = callbackFn;
    this.callbackObj = callbackObj;
    this.dbgDiv = div;

    this.Reset();
}

Loader.prototype.Reset = function() {
    this.setStatus('null');
};

Loader.prototype.setStatus = function(st) {
    this.status = st;
    LogDebugMsg(this.dbgDiv, 'Status: ' + this.status);
};

Loader.prototype.canRetry = function() {
    return baina.getNetInfo() ? false : true;
};

Loader.prototype.preloadTriggered = function() {
    return this.status == 'preloading' || this.status == 'preloaded';
};

Loader.prototype.Load = function(url, fPreLoad) {
    switch (this.status) {
    case 'null':
    case 'error':
        if (fPreLoad) {
            this.setStatus('preloading');
        } else {
            this.setStatus('loading');
        }
        this.loadDom.contentWindow.location.replace(url);
        break;

    case 'preloading':
        if (!fPreLoad) {
            this.setStatus('loading');
        }
        break;

    case 'preloaded':
        if(!fPreLoad) {
            this.setStatus('loading');
            this.OnLoaded();
        }
        break;
    }
};

Loader.prototype.OnLoaded = function() {
    var isOK = this.loadDom.contentWindow.dp_ok;

    if (!isOK) {
        var canRetry = this.canRetry();
        this.setStatus('error');
        this.callbackFn && this.callbackFn.call(this.callbackObj, canRetry);
    } else {
        switch (this.status) {
        case 'preloading':
            this.setStatus('preloaded');
            break;

        case 'loading':
            this.setStatus('loaded');
            if (this.callbackFn) {
                this.callbackFn.call(this.callbackObj);
            }
            break;
        }
    }
};

/*main Function*/
function AutoPager() {
    this.foldClass = 'd_ap_footer_hidden';
    this.IsInitNum = !!dp_page_num;
    this.preLoadNum = dp_page_num || 1;
    this.nextLoadNum = dp_page_num || 1;
    this.preSplitter = false;
    this.nextSplitter = false;
    this.IsPreErrorPage = false;
    this.IsNextErrorPage = false;
    
    this.foldPage = 0;
    this.pageArray = [];
    this.heightDiff = 0;
    this.pageArray.push(0);
    this.isFirstPageShow = false;
    this.isFirstPageUrl = true;

    this.winInnerHeight = 0;
    this.touchendtimeFn = 0;
    this.touchendtimeFnCount = 3;
    if (debugReader) {
        this.dbgDiv = CreateDebugDiv('AutoPager', 0);
    }
}
/*初始化Loader和Bar，同时修改第一页*/
AutoPager.prototype.Init = function() {
    this.FirstPageBuild();

    this.topFather = baina.$('dp_title_and_content');

    this.topBar = new Bar('dp_prev_area');
    this.bottomBar = new Bar('dp_next_area');

    this.topBar.Init();
    this.bottomBar.Init();
    this.loadingCut();

    var dbgDivPrevLoader;
    var dbgDivNextLoader;
    if (debugPrevLoader) {
        dbgDivPrevLoader = CreateDebugDiv('PrevLoader', 1);
    }
    if (debugNextLoader) {
        dbgDivNextLoader = CreateDebugDiv('NextLoader', 2);
    }
    this.prevLoader = new Loader('dp_prev_frame', this, this.OnPrevLoaded, dbgDivPrevLoader);
    this.nextLoader = new Loader('dp_next_frame', this, this.OnNextLoaded, dbgDivNextLoader);

    var self = this;
    var prevIframe = baina.$('dp_prev_frame');
    var nextIframe = baina.$('dp_next_frame');
    baina.addEvent(prevIframe, 'load', function(){
        setTimeout(function(){self.prevLoader.OnLoaded();}, 100);
    });
    baina.addEvent(nextIframe, 'load', function(){
        setTimeout(function(){self.nextLoader.OnLoaded();}, 100);
    });
    this.winInnerHeight = window.innerHeight;
    baina.addEvent(window, 'resize', function () {
        self.winInnerHeight = window.innerHeight;
    });
    LogDebugMsg(this.dbgDiv, 'Initialized');
};
AutoPager.prototype.FirstPageBuild = function() {
    var autoPagerDom = this.FirstPageDom();
    baina.addChildEnd(document.body, autoPagerDom, false);
    var contentWrapInit = baina.$('dp_content_1_c');
    var bodyChilds = document.body.childNodes;
    for(var i = 1; i < bodyChilds.length-1;){
        if(bodyChilds[i].nodeName == 'SCRIPT'){
            i += 1;
        } else {
            contentWrapInit.appendChild(bodyChilds[i]);
        }
    }
    var contentInit = baina.$('dp_content_1');
    contentInit.setAttribute('link_url', window.location.href);
    var contentWrapInitF = baina.firstElemChild(contentWrapInit.firstChild);
    contentWrapInitF.style['position'] ='relative';
    contentWrapInitF.style['float'] ='none';
};
AutoPager.prototype.FirstPageDom = function() {
    var iFragment = document.createDocumentFragment();
    var domWrap = document.createElement('div');
    domWrap.id = 'dp_body_div';
    domWrap.innerHTML = '<div class="dp_preload_frame"><iframe id="dp_prev_frame"></iframe><iframe id="dp_next_frame"></iframe></div><div id="dp_prev_area"><div id="dp_prev_loading_tip" class="recover_loading"><div class="recover_wrap"><span class="dp_rc_pic">&nbsp;</span><span class="dp_rc_text">&#x52A0;&#x8F7D;&#x4E2D;...</span><span class="dp_rc_error">&nbsp;</span></div><div class="stop_wrap"><span class="dp_st_text">&#x5DF2;&#x6682;&#x505C;&#x52A0;&#x8F7D;</span><span class="dp_st_pic">&nbsp;</span></div></div><div id="dp_prev_loading_error_tip"><span class="dp_text">&#x7F51;&#x7EDC;&#x9519;&#x8BEF;&#xFF0C;&#x8BF7;<span id="dp_prev_retry_btn">&#x91CD;&#x8BD5;</span></span></div><div id="dp_prev_boundary_tip"><span>&#x5DF2;&#x5230;&#x8FBE;&#x7B2C;&#x4E00;&#x9875;</span><div class="fold_bg"></div></div><div id="dp_prev_fn_error_tip"><span class="dp_fe_text">&#x81EA;&#x52A8;&#x7FFB;&#x9875;&#x524D;&#x8FDB;&#x53D7;&#x963B;</span><a href="" id="dp_prev_error_url">&#x70B9;&#x51FB;&#x8FDB;&#x5165;</a></div></div>    <div id="dp_title_and_content"><div id="dp_content_1" class="dp_content_wrap"><div id="dp_content_1_c"></div></div></div><div id="dp_next_area"><div id="dp_next_loading_tip"  class="recover_loading"><div class="recover_wrap"><span class="dp_rc_pic">&nbsp;</span><span class="dp_rc_text">&#x52A0;&#x8F7D;&#x4E2D;...</span><span class="dp_rc_error">&nbsp;</span></div><div class="stop_wrap"><span class="dp_st_text">&#x5DF2;&#x6682;&#x505C;&#x52A0;&#x8F7D;</span><span class="dp_st_pic">&nbsp;</span></div></div><div id="dp_next_loading_error_tip"><span class="dp_text">&#x7F51;&#x7EDC;&#x9519;&#x8BEF;&#xFF0C;&#x8BF7;<span id="dp_next_retry_btn">&#x91CD;&#x8BD5;</span></span></div><div id="dp_next_boundary_tip"><div class="fold_bg"></div><span>&#x5DF2;&#x7ECF;&#x662F;&#x6700;&#x540E;&#x4E00;&#x9875;&#x4E86;</span></div><div id="dp_next_fn_error_tip"><span class="dp_fe_text">&#x81EA;&#x52A8;&#x7FFB;&#x9875;&#x524D;&#x8FDB;&#x53D7;&#x963B;</span><a href="" id="dp_next_error_url">&#x70B9;&#x51FB;&#x8FDB;&#x5165;</a></div></div>';
    iFragment.appendChild(domWrap);
    return iFragment;
};
/*修改传入的节点，并添加到主frame*/
AutoPager.prototype.CutOutContent = function(contentDom, idNum, url, isAddToEnd) {
    var contentWrap = contentDom;
    contentWrap.id += 'dp_content_' + idNum;
    contentWrap.setAttribute('link_url', url);
    var contentWrapChild = baina.firstElemChild(contentWrap.firstChild);
    contentWrapChild.id = 'dp_content_' + idNum + '_c';
    var content = baina.firstElemChild(contentWrapChild.firstChild);
    content.style['position'] ='relative';
    content.style['float'] ='none';

    var barDom = (isAddToEnd != false) ? this.bottomBar : this.topBar;
    barDom.ShowLoaddingTip(false);
    baina.addChildEnd(this.topFather, contentWrap, isAddToEnd);
};
/*创建错误页面，去掉页面中的JS脚本*/
AutoPager.prototype.loadErrorPage = function(iframeDom, idNum, url, isAddToEnd) {
    var errorPage = document.getElementsByClassName('errorPage');
    var contentFChild = document.createElement('div');
    var content = document.createElement('div');
    var wrap = document.createElement('div');
    wrap.className = 'errorPage';
    var errorPageInnerHTML = iframeDom.contentDocument.body.innerHTML;
    errorPageInnerHTML = errorPageInnerHTML.replace(/<script.*<\/script>/gi, '');
    wrap.innerHTML = errorPageInnerHTML;
    content.className = 'dp_content_wrap';
    contentFChild.appendChild(wrap);
    content.appendChild(contentFChild);
    this.CutOutContent(content, idNum, url, isAddToEnd);
};
/*初始预加载*/
AutoPager.prototype.PrefetchIfNecessary = function() {
    if(this.topFather.clientHeight > this.winInnerHeight){
        this.LoadNextPage(true);
    } else {
        this.nextSplitter = true;
        var splitterDiv = this.splitterBar(this.nextLoadNum + 1);
        this.topFather.appendChild(splitterDiv);
        this.bottomBar.ShowLoaddingTip();
        this.foldCut(this.nextLoadNum + 1);
        this.nextLoader.Load(dp_next_url, false);
    }
    if(dp_prev_url){
        this.LoadPrevPage(true);
    }
};

AutoPager.prototype.GetCurrentPage = function() {
    var y = window.scrollY;
    for (var i = this.pageArray.length - 1; i >= 0; --i) {
        if (y >= this.pageArray[i]) {
            break;
        }
    }
    return i;
};

AutoPager.prototype.LoadPrevPage = function(fPreLoad) {
    LogDebugMsg(this.dbgDiv, 'LoadPrevPage preload: ' + fPreLoad);
    if (dp_prev_url) {
        this.prevLoader.Load(dp_prev_url, fPreLoad);
    }
};

AutoPager.prototype.LoadNextPage = function(fPreLoad) {
    LogDebugMsg(this.dbgDiv, 'LoadNextPage preload: ' + fPreLoad);
    if(!dp_next_url){
        this.bottomBar.ShowBoundaryTip();
        this.nextSplitter = true;
        return ;
    }
    if(!this.nextSplitter){
        var splitterDiv = this.splitterBar(this.nextLoadNum + 1);
        this.topFather.appendChild(splitterDiv);
        this.bottomBar.ShowLoaddingTip();
        this.foldCut(this.nextLoadNum + 1);
        this.nextSplitter = true;
    }
    this.nextLoader.Load(dp_next_url, fPreLoad);
};

/* 添加页面
** 通过Loader的status判断加载什么页面，错误页面或者正常页面
** 向前加载还需要处理上一页的地址和本页的地址是否一样，来源于bug反馈
** 超过9页需要删除多余的页面，用于确保页面的性能
**/
AutoPager.prototype.OnPrevLoaded = function(canRetry) {
    var dp_prev_frame = baina.$('dp_prev_frame');
    if (this.prevLoader.status == 'error') {
        LogDebugMsg(this.dbgDiv, 'OnPrevLoaded failed retry: ' + canRetry);
        if (canRetry == false) {
            if (!dp_prev_frame.contentDocument) {
                this.topBar.ShowFnErrorTip();
                baina.$('dp_prev_error_url').href = dp_prev_url;
                return ;
            }
            if (!this.IsPreErrorPage) {
                this.preLoadNum -= 1;
                this.loadErrorPage(dp_prev_frame, this.preLoadNum, dp_prev_url, false);
                dp_prev_url = dp_prev_frame.contentWindow.dp_prev_url;
                this.IsPreErrorPage = true;
            }
        } else {
            this.topBar.IsErrorTipShow() || this.topBar.ShowErrorTip();
        }
        this.prevLoader.Reset();
    } else {
        LogDebugMsg(this.dbgDiv, 'OnPrevLoaded done');

        var temp_dp_prev_url = dp_prev_frame.contentWindow.dp_prev_url;
        if(temp_dp_prev_url == dp_prev_url){
            this.topBar.ShowLoaddingTip(false);
            this.topFather.removeChild(this.topFather.firstChild);
            if(this.isFirstPageShow){
                this.topBar.IsBoundaryTipShow() || this.topBar.ShowBoundaryTip();
            }
            this.prevLoader.Reset();
            return;
        }

        this.preLoadNum -= 1;
        if(this.nextLoadNum - this.preLoadNum > 8){
            this.bottomBar.IsBoundaryTipShow() && this.bottomBar.ShowBoundaryTip(false);
            this.bottomBar.IsErrorTipShow() && this.bottomBar.ShowErrorTip(false);
            this.bottomBar.IsFnErrorTipShow() && this.bottomBar.ShowFnErrorTip(false);
            var oldUrlDOM = this.topFather.lastChild;
            if(baina.hasClass(oldUrlDOM, 'dp_splitter_wrap')){
                this.topFather.removeChild(oldUrlDOM);
            }
            dp_next_url = this.topFather.lastChild.getAttribute('link_url');
            this.topFather.removeChild(this.topFather.lastChild);
            this.topFather.removeChild(this.topFather.lastChild);
            this.IsNextErrorPage = false;
            this.nextSplitter = false;
            this.nextLoadNum -= 1;
            this.pageArray.length = this.pageArray.length-1;
        }

        var oldHeight = document.height;

        var content = dp_prev_frame.contentDocument.getElementById('dp_content_1');
        this.CutOutContent(content, this.preLoadNum, dp_prev_url, false);
        this.foldCut(this.preLoadNum+1);

        var diff = document.height - oldHeight;
        for (var i = 0; i < this.pageArray.length; ++i) {
            this.pageArray[i] += diff;
        }
        this.pageArray.unshift(0);
        var go = this.pageArray[1];
        window.scrollTo(0, go);
        this.preSplitter = false;
        dp_prev_url = temp_dp_prev_url;

        this.prevLoader.Reset();
        this.LoadPrevPage(true);
    }
};

AutoPager.prototype.OnNextLoaded = function(canRetry) {
    LogDebugMsg(this.dbgDiv, 'OnNextLoaded failed retry:' + canRetry);
    var dp_next_frame = baina.$('dp_next_frame');
    if (this.nextLoader.status == 'error') {
        LogDebugMsg(this.dbgDiv, 'OnNextLoaded failed retry:' + canRetry);
        if (canRetry == false) {
            if(!dp_next_frame.contentWindow.document){
                this.bottomBar.ShowFnErrorTip();
                baina.$('dp_next_error_url').href = dp_next_url;
                this.IsNextErrorPage = true;
            }
            if(!this.IsNextErrorPage) {
                this.nextLoadNum += 1;
                this.loadErrorPage(dp_next_frame, this.nextLoadNum, dp_next_url);
                dp_next_url = dp_next_frame.contentWindow.dp_next_url;
                this.IsNextErrorPage = true;
            }
        } else {
            this.bottomBar.IsErrorTipShow() || this.bottomBar.ShowErrorTip();
        }
        this.nextLoader.Reset();
    } else {
        LogDebugMsg(this.dbgDiv, 'OnNextLoaded done');
        this.nextLoadNum += 1;

        if(this.nextLoadNum - this.preLoadNum > 8){
            this.topBar.IsBoundaryTipShow() && this.topBar.ShowBoundaryTip(false);
            this.topBar.IsErrorTipShow() && this.topBar.ShowErrorTip(false);
            this.topBar.IsFnErrorTipShow() && this.topBar.ShowFnErrorTip(false);
            var oldUrlDOM = this.topFather.firstChild;
            if(baina.hasClass(oldUrlDOM, 'dp_splitter_wrap')){
                this.topFather.removeChild(oldUrlDOM);
            }
            dp_prev_url = this.topFather.firstChild.getAttribute('link_url');
            var scrollNow = window.scrollY;
            scrollNow -= this.pageArray[1];

            this.topFather.removeChild(this.topFather.firstChild);
            this.topFather.removeChild(this.topFather.firstChild);
            window.scrollTo(0, scrollNow);
            
            this.isFirstPageShow = true;
            this.IsPreErrorPage = false;
            this.preSplitter = false;
            this.preLoadNum += 1;

            var tempArray = [];
            var tempPageArray = this.pageArray;
            for(var i = tempPageArray.length -1; i>0; i--){
                tempArray[i-1] = tempPageArray[i] - tempPageArray[1];
            }
            this.pageArray = tempArray;
            var self = this;
            setTimeout(function() {
                self.lazyLoad()}, 100);
        } else {
            this.lazyLoad();
        }
    }
};

/*由于删除第一页，有时不能准确获取到document.height，所以加一个延时*/
AutoPager.prototype.lazyLoad = function() {
    var position = document.height - 73;
    this.pageArray.push(position);
    var dp_next_frame_temp = baina.$('dp_next_frame');
    var content = dp_next_frame_temp.contentDocument.getElementById('dp_content_1');
    this.CutOutContent(content, this.nextLoadNum, dp_next_url);

    dp_next_url = dp_next_frame_temp.contentWindow.dp_next_url;
    if(this.isFirstPageUrl){
        var preUrl = dp_next_frame_temp.contentWindow.dp_prev_url;
        baina.$('dp_content_1').setAttribute('link_url', preUrl);
        this.isFirstPageUrl = false;
    }
    this.nextSplitter = false;
    this.nextLoader.Reset();
    this.LoadNextPage(true);
};

AutoPager.prototype.OnTouchStart = function(e) {
    this.touchStartPos = e.touches[0].pageY;
    this.loadTriggered = false;
    clearTimeout(this.touchendtimeFn);
};
/* 滑动检查
** 先判断向上或者向下滑动，然后再判断是否到达加载区域
** 在判断是否是页尾，是否创建
**/
AutoPager.prototype.OnTouchMove = function(e) {
    var diff = e.touches[0].pageY - this.touchStartPos;
    if (diff > 5) {
        if (window.scrollY < 10) {
            if (!this.loadTriggered && !this.topBar.IsErrorTipShow()) {
                this.loadTriggered = true;
                if(!dp_prev_url){
                    if(this.isFirstPageShow){
                        this.topBar.ShowBoundaryTip();
                    }
                    this.preSplitter = true;
                    return ;
                }
                if(!this.preSplitter){
                    this.preSplitter = true;
                    var splitterDiv = this.splitterBar(this.preLoadNum);
                    this.topFather.insertBefore(splitterDiv, this.topFather.childNodes[0]);
                    this.topBar.ShowLoaddingTip();
                }
                this.LoadPrevPage(false);
            }
        }
    } else {
        this.heightDiff = document.height - this.winInnerHeight - 180;
        if (window.scrollY >= this.heightDiff) {
            if (!this.loadTriggered && !this.bottomBar.IsErrorTipShow()) {
                this.loadTriggered = true;
                this.LoadNextPage(false);
            }
        }
    }
};

/* 在手指离开调用OnScroll(这里应该添加延迟)
** 用以检查是否滑动到加载页面的区域，同时分为3次延时去检查
**/
AutoPager.prototype.OnTouchEnd = function() {
    this.loadTriggered = false;
    this.touchendtimeFnCount = 3;
    var self = this;
    self.touchendtimeFn = setTimeout(function(){self.OnScroll()}, 300);
};

AutoPager.prototype.OnScroll = function() {
    this.heightDiff = document.height - this.winInnerHeight - 180;
    if (window.scrollY >= this.heightDiff) {
        if (!this.bottomBar.IsErrorTipShow()) {
            clearTimeout(this.touchendtimeFn);
            this.LoadNextPage(false);
            return ;
        }
    }

    var self = this;
    if(this.touchendtimeFnCount == 1){
        clearTimeout(this.touchendtimeFn);
    } else {
        this.touchendtimeFn = setTimeout(function(){self.OnScroll()}, 300);
        this.touchendtimeFnCount -= 1;
    }
};

/*分隔条创建*/
AutoPager.prototype.splitterBar = function(pageNum) {
    var frag = document.createDocumentFragment();
    var splitterWrap = document.createElement('div');
    var ihtml = '<div class="fold_bg"></div>';
    if(this.IsInitNum){
        ihtml += '<span class="pageNum">'+ pageNum + '</span>';
    }
    ihtml += '<div class="clickarea" id="splitterFold_'+ pageNum +'"><div class="clickup"></div><div class="clickdown"></div></div><div class="foldarea" id="foldarea_' + pageNum + '"></div>';
    splitterWrap.innerHTML = ihtml;
    splitterWrap.className = 'dp_splitter_wrap dp_fold dp_fold_init';
    frag.appendChild(splitterWrap);
    return frag;
};

/* 展开页尾
** dp_footer_hidden的替换为自己的dp_fold_open，不会影响原来的样式
** 首次展开获得当页的高度，设置为oldHeight以便折叠时做动画效果
** 折叠动画回滚的时候，将滚动分为多个小任务（延时），希望更加流畅
**/
AutoPager.prototype.foldCut = function(num) {
    var self = this;
    var splitterFold = baina.$('splitterFold_' + num);
    var splitterFoldP = splitterFold.parentNode;
    splitterFoldP.className = 'dp_splitter_wrap dp_fold';

    var foldarea = baina.$('foldarea_' + num);
    var foldareaP = foldarea.parentNode;
    if(splitterFold == null || foldarea == null){return}

    baina.addEvent(splitterFold, 'click', function(){
        var hideElemP = baina.prevSibling(splitterFoldP);
        var oldH = hideElemP.firstChild.clientHeight;
        hideElemP.style['height'] = oldH + 'px';
        hideElemP.setAttribute('oldH', oldH);
        self.foldPage = window.scrollY;
        setTimeout(function(){
            var splitterObject = hideElemP.getElementsByClassName(self.foldClass);
            var replaceReg = new RegExp('\\b'+ self.foldClass + '\\b', 'g');

            for(var i = splitterObject.length; i>0; i--){
                splitterObject[0].className = splitterObject[0].className.replace(replaceReg, "dp_fold_open");
            }
            hideElemP.className += ' dp_con_wrap_ani';
            var newH = hideElemP.firstChild.clientHeight;
            hideElemP.style['height'] = newH + 'px';
            splitterFoldP.className = 'dp_splitter_wrap dp_unfold';
        }, 50);
    });

    baina.addEvent(foldarea, 'click', function(){
        var showElemP = baina.prevSibling(foldareaP);
        var oldH = showElemP.getAttribute('oldH');

        showElemP.style['height'] = oldH + 'px';
        foldareaP.className = 'dp_splitter_wrap dp_fold';
        setTimeout(function(){
            showElemP.className = 'dp_content_wrap';
            var splitterObject = showElemP.getElementsByClassName('dp_fold_open');
            var replaceReg = new RegExp('\\bdp_fold_open\\b', 'g');

            for(var i = splitterObject.length; i>0; i--){
                splitterObject[0].className = splitterObject[0].className.replace(replaceReg, self.foldClass);
            }
            var scrollNow = window.scrollY;
            var dis = (scrollNow - self.foldPage)/10;
            var i = 10;
            var y= setInterval(function(){
                if(i>0){
                    scrollNow-=dis;
                    window.scrollTo(0, scrollNow);
                    i-=1;
                } else {
                    clearInterval(y);
                }
            } ,20);
        }, 200);
    });
};
/*loading状态切换，采用切换className来实现*/
AutoPager.prototype.loadingCut = function() {
    var self = this;
    var topDom = this.topBar.loadingTip.dom;
    var bottomDom = this.bottomBar.loadingTip.dom;

    baina.addEvent(topDom, 'click', function(){
        if(topDom.className == "recover_loading"){
            self.prevLoader.loadDom.contentWindow.stop();
            topDom.className = 'stop_loading'; 
        } else {
            topDom.className = 'recover_loading';
            self.prevLoader.Reset();
            self.prevLoader.Load(dp_prev_url, false);
        }
    });
    baina.addEvent(bottomDom, 'click', function(){
        if(bottomDom.className == "recover_loading"){
            self.nextLoader.loadDom.contentWindow.stop();
            bottomDom.className = 'stop_loading';
        } else {
            bottomDom.className = 'recover_loading';
            self.nextLoader.Reset();
            self.nextLoader.Load(dp_next_url, false);
        }
    });
};
/*页面控制，侦听滑动事件，和重试*/
var pageControl = {
    dp_body_div: null,
    dp_prev_area: null,
    dp_next_area: null,
    controlTarget: null,
    dp_prev_retry_btn: null,

    init: function (target) {
        var self = this;
        self.controlTarget = target;
        self.dp_body_div = baina.$('dp_body_div');

        baina.addEvent(self.dp_body_div, 'touchstart', function (e) {self.controlTarget.OnTouchStart(e);} );
        baina.addEvent(self.dp_body_div, 'touchmove', function (e) {self.controlTarget.OnTouchMove(e);} );
        baina.addEvent(self.dp_body_div, 'touchend', function (e) {self.controlTarget.OnTouchEnd(e);} );

        self.dp_prev_retry_btn = baina.$('dp_prev_retry_btn');
        self.dp_next_retry_btn = baina.$('dp_next_retry_btn');

        baina.addEvent(self.dp_prev_retry_btn, 'touchstart', function (e) {self.OnRetryBtnPress(self.dp_prev_retry_btn, e)} );
        baina.addEvent(self.dp_next_retry_btn, 'touchstart', function (e) {self.OnRetryBtnPress(self.dp_next_retry_btn, e)} );
        baina.addEvent(self.dp_prev_retry_btn, 'touchend', function (e) {self.OnRetryBtnUp(self.dp_prev_retry_btn, e)} );
        baina.addEvent(self.dp_next_retry_btn, 'touchend', function (e) {self.OnRetryBtnUp(self.dp_next_retry_btn, e)} );
    },
    /*添加点击效果，可以去掉*/
    OnRetryBtnPress: function (dom, e) {
        baina.stopEvent(e);

        baina.hasClass(dom, "dp_retry_press") || baina.addClass(dom, "dp_retry_press");
    },
    /*重新设置iframe的src，尝试请求*/
    OnRetryBtnUp: function (dom, e) {
        baina.stopEvent(e);
        baina.removeClass(dom, "dp_retry_press");

        if (dom.id == "dp_next_retry_btn") {
            this.controlTarget.bottomBar.ShowLoaddingTip();
            this.controlTarget.LoadNextPage(false);
        } else if (dom.id == "dp_prev_retry_btn") {
            this.controlTarget.topBar.ShowLoaddingTip();
            this.controlTarget.LoadPrevPage(false);
        }
    }
};
/*Auto Page Js Code Running*/
var dp_reader = new AutoPager();
dp_reader.Init();
dp_reader.PrefetchIfNecessary();
pageControl.init(dp_reader);

/*@ToDo：
** 1:当第一页加载后，如果不是从第一页进来的，当向上翻页的时候，需要从新覆盖第一页的Url，下一页的已经做了处理。
** 2:当向上滑动的时候需要计算滚动的位置，现在的状况是多滚了49个px。
** 3:当超过九个页面的时候，滚动的距离需要重新计算和优化，在开始时的时候需要设置好pageArray。
** 
**/

/*@maybe:
** 1:loading Bar的控制部分是不是应该写到PageControl部分？
** 2:重试的函数，应该直接使用Load而不是LoadPrevPage，此时的url是有效地，分隔条也已经创建！
** 3:在OnScroll函数中，应该添加对向上滑的判断？
** 4:由于display:none不会对页面有太大的影响，可以考虑将多余的页面隐藏，下次就不用再去求情了！
**/


/*@modify：
**1:修改了添加的id编号，使他与当前页码对应。
**2:IsFirstUse是对首次使用该功能的API接口。
**3:initclass是对于底部隐藏的内容的class。
**4:修改了取消加载和恢复加载的API接口。
**5:添加了页面的限制，超过九个的时候会删除边缘页面。
**6:对隐藏的元素进行隐藏和显示
**/

/*@ToDo：
*~*1:提供展开的className接口？？放在那里呢？
**2:取消和恢复加载还有增加一些图片。
*~*3:刚进入的时候需要对第一页的ID进行设置。
**4:prev_url什么时候设置？
**5:取消和恢复加载功能为实现。
**6:向上加载未能实现。
**/

/*
**1：找到loading的时机来实现暂停加载。
**/

/*@risk:
**1:每次对刚进入的页面进行了script的判断，是否会影响加载速度？
**/
